/* Autor:           Dipl.-Inf., Dipl.-Ing. (FH) Michael Wilhelm
   Firma:           HS Harz, FB AI
   Version:         1.1
   Ersterstellung:  05.09.2007
   Letzte nderung: 12.11.2010
*/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

// Anzeige mehrerer Bilder mittels SetBounds
// Simulation von Memory

public class MemJong extends JFrame {

  String PictBlank = "bild0.gif";
  String [] Pictfiles = {
                      "bild1.gif",
                      "bild2.gif",
                      "bild3.gif",
                      "bild4.gif",
                      "bild5.gif",
                      "bild6.gif",
                      "bild7.gif",
                      "bild8.gif",
                      "bild9.gif",
                      "bild10.gif",
                      "bild11.gif",
                      "bild12.gif",
                      "bild13.gif",
                      "bild14.gif"
                    };

  MyJLabel[] Pictlabels;

  //Frame konstruieren
  public MemJong() {
    this.setSize(new Dimension(800, 600));
    setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
    this.setTitle("MemJong");
    setGUI();
  }



  //Initialisierung der Komponente
  private void setGUI() {
    int nr, i, j, t, l;

    ImageIcon image;
    this.getContentPane().setLayout( null );
    Pictlabels = new MyJLabel[ Pictfiles.length << 1 ]; // nur Array

    nr = -1;
    for (i=0; i<Pictfiles.length; i++) {
      for (j=0; j<2; j++) {
       Pictlabels[++nr] = new MyJLabel(i, PictBlank, Pictfiles[i]);
       image = loadIcon( Pictfiles[i]);
       t = (int) (Math.random()*getHeight()*0.8);
       l = (int) (Math.random()*getWidth()*0.8);
       this.getContentPane().add( Pictlabels[nr] );
       Pictlabels[nr].setBounds(l,t,image.getIconWidth(), image.getIconHeight() );
       System.out.println(i+"  "+image.getIconWidth()+"  "+image.getIconHeight() );
       Pictlabels[nr].addMouseListener(new java.awt.event.MouseAdapter() {
          public void mouseClicked(MouseEvent e) {
          Pictlabel_mouseClicked(e);
        }
       });
       } // for j
    } // for j

  }  // setGUI



  void Pictlabel_mouseClicked(MouseEvent e) {
  int i, anz, index1, nr1, nr2;
    MyJLabel Pictlabel = (MyJLabel) e.getSource();
    System.out.println("Mouse Click Nr: "+Pictlabel.nr);
    //
    anz=0;
    nr1=-1;
    index1=-1;
    for (i=0; i<(Pictfiles.length << 1); i++) {
      if (Pictlabels[i].getStateOpen() ) {
        anz++;
        nr1 = Pictlabels[i].nr; // fr den Vergleich notwendig
        index1=i;
        System.out.println("Index1: "+i);
      }
    }
    //System.out.println("P1");
    if (index1==-1)
      System.out.println("Index1 ist negativ");

    if (anz==1) {
      Pictlabel.setStateOpen(true);
      nr2 = Pictlabel.nr; // fr den Vergleich notwendig
      if (nr1==nr2) {
        Message("MemJong","Herzlichen Glckwunsch\nDie Bilder passen!");
        // nun die Bilder rausnehmen
        Pictlabels[index1].setStateOpen(false);
        Pictlabel.setStateOpen(false);

        Pictlabels[index1].setBounds(0,0,0,0);
        Pictlabel.setBounds(0,0,0,0);
      }
      else {
        Message("MemJong","Bitte noch einmal versuchen");
        Pictlabels[index1].setStateOpen(false);
        Pictlabel.setStateOpen(false);
      }
    }
    if (anz==0) {
      Pictlabel.setStateOpen(true);
    }
  }

  public void Message( String sTitle, String sMessage) {
    JOptionPane.showConfirmDialog(null,sMessage,sTitle,
      JOptionPane.DEFAULT_OPTION,
      JOptionPane.INFORMATION_MESSAGE);  // Symbol
  } // Message


  private ImageIcon loadIcon(String name) {
    return new ImageIcon(name);
  }




  public static void main(String[] args) {
    MemJong frame = new MemJong();
    frame.setVisible(true);
  }


}


class MyJLabel extends JLabel {

   ImageIcon image0;
   ImageIcon image;

   public int nr;
   private boolean bStateOpen=false;

   private String fileBlank;
   private String file;

   public MyJLabel(int nr, String fileBlank, String file) {
    super();
    this.nr = nr;
    this.fileBlank = fileBlank;
    this.file = file;
    image0 = loadIcon( fileBlank);
    image = loadIcon( file);
    setIcon( image0 );
   }

  private ImageIcon loadIcon(String name) {
    return new ImageIcon(name);
  }

  public void setStateOpen(boolean bStateOpen) {
    if (bStateOpen)
      setIcon( image );
    else
      setIcon( image0 );
    this.bStateOpen = bStateOpen;
  }

  public boolean getStateOpen() {
    return this.bStateOpen;
  }

   public MyJLabel() {
    super();
    this.nr = 0;
   }


  public MyJLabel(String text) {
    super(text);
   }

   public MyJLabel(Icon image) {
     super(image);
   }

   public MyJLabel(Icon image, int horizontalAlignment) {
     super(image, horizontalAlignment);
   }

   public MyJLabel(String text, Icon image, int horizontalAlignment) {
     super(text, image, horizontalAlignment);
   }

   public MyJLabel(String text, int horizontalAlignment) {
     super(text, horizontalAlignment);
   }



}
